/***************************************************************************
  par UTPECA d'après Rui Santos
  Complete project details at 
  https://RandomNerdTutorials.com/esp32-async-web-server-espasyncwebserver-library/
  https://RandomNerdTutorials.com/display-images-esp32-esp8266-web-server/
  https://randomnerdtutorials.com/esp-now-esp32-arduino-ide/
  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.
****************************************************************************/

// Import required libraries 
#ifdef ESP32
  #include <esp_now.h>
  #include <WiFi.h>
  #include <AsyncTCP.h>
  #include <ESPAsyncWebServer.h>
  #include <SPIFFS.h>
#else
  #include <Arduino.h>
  #include <espnow.h>
  #include <ESP8266WiFi.h>
  #include <Hash.h>
  #include <ESPAsyncTCP.h>
  #include <ESPAsyncWebServer.h>
  #include "FS.h"
#endif

/*--------------------------------------------------------------------------
 * DONNEES DE LA TACHE TCO_WEB
---------------------------------------------------------------------------*/
// Connection au routeur wifi (la box)
#define DEBUG
#define NBMOT 8
#define NBMAC 2
const char* ssid     = "... le nom de votre routeur ...";
const char* password = "... votre mot de passe ...";

// communication entre le serveur et la page HTML (browser)
const char* PARAM_INPUT_1 = "output"; // Nom de l'appareil
const char* PARAM_INPUT_2 = "state";  // Etat de l'appareil

/*--------------------------------------------------------------------------
 * DONNEES PROTOCOLE ESP-NOW
---------------------------------------------------------------------------*/

typedef struct 
{
  bool    actif;
  uint8_t bcAdr[6];
} recepteur;

// Table des RECEIVER'S MAC ADDRESS
recepteur t_Mac[NBMAC] =
{
  { false, {0x10, 0x97, 0xBD, 0xE4, 0xBF, 0x64}},
  { false, {0xAC, 0x0B, 0xFB, 0xD9, 0x8A, 0xA0}}
};

typedef struct  
{
  byte   numApp;    // numéro appareil (de 1 à 8)
  char   typApp;    // type de l'appareil ('A', 'J', 'T', 'S')
  char   etaApp;    // état de l'appareil ( de '1' à '4')
  byte   noMot1;    // No du 1er moteur (de 1 à 8)
  byte   noMot2;    // No du 2me moteur (de 1 à 8)
} comm;

//Create a struct_message called myComm
comm myComm;

// gestion des appariements
#ifdef ESP32
esp_now_peer_info_t peerInfo;
#endif

// Create AsyncWebServer object on port 80
AsyncWebServer server(80);

const char index_html[] PROGMEM = R"rawliteral(
<!DOCTYPE HTML><html>
<head>
  <title>TCO par UTPECA</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="icon" href="data:,">
  <style>
    html {font-family: Arial; display: inline-block; text-align: left;}
    h2 {font-size: 3.0rem;}
    p {font-size: 15px; font-weight: bold; width: 400px; margin-left: 30px; padding-bottom: 2px; padding-top: 2px; border: 2px solid #6B6B94}
    .img1 {border: 0px; width: 64px; height=64px;}
    body {max-width: 1280px; margin:0px auto; padding-bottom: 10px; padding-top: 10px;}
  </style>
</head>
<body background='Pierre' >
<table border='0' width='1280' cellspacing='0' cellpadding='0'>
<tr><td><img border='0' src='Titre2'</td></tr>
<tr><td><img border='0' src='Ligne'</td></tr></table>
 
%CONSTRUIRE_TCO%

<table><tr><td><img border='0' src='Ligne'</td></tr></table>
<p id='DESC'> &nbsp;Manoeuvrez un appareil</p>
<table><tr><td><img border='0' src='Ligne'</td></tr></table>

<script>
var posApp1 = '%VALEUR_APP1%';
var posApp2 = '%VALEUR_APP2%';
var posApp3 = '%VALEUR_APP3%';
var posApp4 = '%VALEUR_APP4%';
var posApp5 = '%VALEUR_APP5%';
var posApp6 = '%VALEUR_APP6%';
var posApp7 = '%VALEUR_APP7%';
var posApp8 = '%VALEUR_APP8%';

function ChangeAig(posApp, kodApp, imgApp, angApp)
{
   var posAig = posApp;
   var xhr = new XMLHttpRequest();
   if ( posAig == "1" )
   {
      posAig = "2";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e";
   }
   else
   {
      posAig = "1";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie directe";
   }
   if ( angApp == '' )
   {
      document.images['img'+kodApp].src=imgApp+'_E'+posAig;
   } 
   else
   {
      document.images['img'+kodApp].src=imgApp+'_E'+posAig+'_'+angApp;
   }
   xhr.open("GET", "/update?output="+kodApp+":A&state="+posAig, true);
   xhr.send();
   return posAig;
}

function ChangeAigS(posApp, kodApp, imgApp, angApp)
{
   var posAig = posApp;
   var xhr = new XMLHttpRequest();
   if ( posAig == "1" )
   {
      posAig = "2";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e &agrave; droite";
   }
   else
   {
      posAig = "1";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e &agrave; gauche";
   }
   if ( angApp == '' )
   {
      document.images['img'+kodApp].src=imgApp+'_E'+posAig;
   } 
   else
   {
      document.images['img'+kodApp].src=imgApp+'_E'+posAig+'_'+angApp;
   }
   xhr.open("GET", "/update?output="+kodApp+":S&state="+posAig, true);
   xhr.send();
   return posAig;
}

function ChangeAigT(posApp, kodApp, imgApp, angApp)
{
   var posAig = posApp;
   var xhr = new XMLHttpRequest();
   if ( posAig == "1" )
   {
      posAig = "2";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e &agrave; gauche";
   }
   else if ( posAig == "2" )
   {
      posAig = "3";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e &agrave; droite";
   }
   else
   {
      posAig = "1";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie directe";
   }
   if ( angApp == '' )
   {
      document.images['img'+kodApp].src=imgApp+'_E'+posAig;
   } 
   else
   {
      document.images['img'+kodApp].src=imgApp+'_E'+posAig+'_'+angApp;
   }
   xhr.open("GET", "/update?output="+kodApp+":T&state="+posAig, true);
   xhr.send();
   return posAig;
}

function ChangeTjd(posApp, kodApp, imgApp, angApp)
{
   var posTjd = posApp;
   var xhr = new XMLHttpRequest();
   if ( posTjd == "1" )
   {
      posTjd = "2";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e";
   }
   else if ( posTjd == "2" )
   {
      posTjd = "3";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie directe";
   }
   else if ( posTjd == "3" )
   {
      posTjd = "4";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e";
   }
   else
   {
      posTjd = "1";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie directe";
   }
   if ( angApp == '' )
   {
      document.images['img'+kodApp].src=imgApp+'_E'+posTjd;
   }
   else
   {
      document.images['img'+kodApp].src=imgApp+'_E'+posTjd+'_'+angApp;
   }
   xhr.open("GET", "/update?output="+kodApp+":J&state="+posTjd, true);
   xhr.send();
   return posTjd;
}

</script>
</body>
</html>
)rawliteral";

// Prise en compte du fichier source du TCO
/*********************************************************************/
#define TCO4
#ifdef TCO1
#include "TCO_Test_Spiffs01.h"
#endif
#ifdef TCO2
#include "PO-Midi2_ifs.h"
#endif
#ifdef TCO4
#include "Mon_TCO_No04_ifs.h"
#endif

/*********************************************************************/
void CommandeAppareil(const String& nomTyp, const String& etaApp) 
/*********************************************************************/
{
  int    colPos = nomTyp.indexOf(':');
  String nomApp = nomTyp.substring(0, colPos);   // nom de l'appareil
  String typApp = nomTyp.substring(colPos+1);    // type de l'appareil (Aig, Tjd, ...
  String numApp = nomTyp.substring(3, colPos);   // numéro de l'appareil
  int    no_App = numApp.toInt() - 1;            // ...en indice de table
  t_App[no_App].etaApp = etaApp[0];              // maj état de l'appareil

  myComm.numApp = no_App;
  myComm.typApp = typApp[0];
  myComm.etaApp = etaApp[0];
  myComm.noMot1 = t_App[no_App].noMot1;
  myComm.noMot2 = t_App[no_App].noMot2;
  int    noMac  = int(t_App[no_App].noRcpt) - 1;

  // Debug : affichage des appareils et de leur état
  //===================================================================
  char macStr[18];
  Serial.print   ( nomApp );
  Serial.print   ( ", Etat" );
  Serial.print   ( etaApp );
  Serial.print   ( " ==> Mac[");
  snprintf(macStr, sizeof(macStr), "%02x:%02x:%02x:%02x:%02x:%02x",
           t_Mac[noMac].bcAdr[0], t_Mac[noMac].bcAdr[1], t_Mac[noMac].bcAdr[2], 
           t_Mac[noMac].bcAdr[3], t_Mac[noMac].bcAdr[4], t_Mac[noMac].bcAdr[5]);
  Serial.print(macStr);
  Serial.print   ( "] : ");

  if ((noMac >= 0) && (t_Mac[noMac].actif)) 
  {
#ifdef ESP32
     esp_err_t result1 = esp_now_send(t_Mac[noMac].bcAdr,  (uint8_t *) &myComm, sizeof(comm));
     (result1 == ESP_OK) ? Serial.print("Envoi OK " ) : Serial.print ("Envoi KO ");
#else
     esp_now_send(t_Mac[noMac].bcAdr,  (uint8_t *) &myComm, sizeof(comm));
     Serial.print("Envoi OK " );
#endif
     delay(500);
  }
  else
  {
     Serial.println("Pas de récepteur");
  }
}

#ifdef ESP32
/*********************************************************************/
void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status)
/*********************************************************************/
// callback when data is sent
{
  Serial.println(status == ESP_NOW_SEND_SUCCESS ? "==> Livraison acceptée" : "==> Livraison refusée");
}
#else
/*********************************************************************/
void OnDataSent(uint8_t *mac_addr, uint8_t status)
/*********************************************************************/
// callback when data is sent
{
  Serial.println(status == 0 ? "==> Livraison acceptée" : "==> Livraison refusée");
}
#endif 

/*********************************************************************/
void InitialiseAppareils() 
/*********************************************************************/
{
//  String nomTyp = "";
  
  for (int i=0;i < NBMOT;i++)
  {
     if (t_App[i].typApp != ' ')
     {
        String etaApp = String(t_App[i].etaApp);
        String nomTyp = "App"+String(i+1)+":"+String(t_App[i].typApp);
        if (t_App[i].noRcpt > 0)
        {
           CommandeAppareil(nomTyp, etaApp);
        }
     }
  }
}

/*********************************************************************/
void setup()
/*********************************************************************/
{
  // Serial port for debugging purposes
  Serial.begin(115200);
   
  // Connection à ESP-NOW
  //------------------------------------------------------------------
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  Serial.print("Initialisation ESP-NOW : ");
  // fonction callback
#ifdef ESP32
  if (esp_now_init() != ESP_OK) {
    Serial.println("Erreur");
    return;
  }
  Serial.println("Ok");
  esp_now_register_send_cb(OnDataSent);
#else
  if (esp_now_init() != 0) {
    Serial.println("Erreur");
    return;
  }
  Serial.println("Ok");
  esp_now_set_self_role(ESP_NOW_ROLE_CONTROLLER);
  esp_now_register_send_cb(OnDataSent);
#endif
   
  // Appairage des récepteurs
  //------------------------------------------------------------------
  // register all peers
  char macStr[18];
  for (int noMac = 0; noMac < NBMAC; noMac++)
  {  
     snprintf(macStr, sizeof(macStr), "%02x:%02x:%02x:%02x:%02x:%02x",
              t_Mac[noMac].bcAdr[0], t_Mac[noMac].bcAdr[1], t_Mac[noMac].bcAdr[2], 
              t_Mac[noMac].bcAdr[3], t_Mac[noMac].bcAdr[4], t_Mac[noMac].bcAdr[5]);
     Serial.print("Appairage avec ");
     Serial.print(macStr);
     Serial.print(" : ");

#ifdef ESP32
     peerInfo.channel = 0;  
     peerInfo.encrypt = false;
     // register peer  
     memcpy(peerInfo.peer_addr, t_Mac[noMac].bcAdr, 6);
     if (esp_now_add_peer(&peerInfo) != ESP_OK)
     {
        Serial.println("Echec");
        t_Mac[noMac].actif = false;
     }
     else
     {
        Serial.println("Ok");
        t_Mac[noMac].actif = true;
     }
#else
  if (esp_now_add_peer(t_Mac[noMac].bcAdr,  ESP_NOW_ROLE_SLAVE, 1, NULL, 0) != 0)
     {
        Serial.println("Echec");
        t_Mac[noMac].actif = false;
     }
     else
     {
        Serial.println("Ok");
        t_Mac[noMac].actif = true;
     }
#endif
  }
  
  // Initialisation SPIFFS
  //------------------------------------------------------------------
  if(!SPIFFS.begin())
  { 
    Serial.println("Initialisation SPIFFS incorrecte");
    return;
  }
  else
  {
    Serial.println("Initialisation SPIFFS : OK");
  }

  // Connection à Wi-Fi
  //------------------------------------------------------------------
  Serial.print   ( "Initialisation Wifi " );
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  // Print ESP Local IP Address
  Serial.println ( "" );
  Serial.print   ( "Maintenant connecté à " );
  Serial.println ( ssid );
  Serial.print   ( "Adresse IP : " );
  Serial.println ( WiFi.localIP() );
  Serial.print   ( "mac Adress : " );
  Serial.println ( WiFi.macAddress() );
  Serial.print   ( "WiFi channel : " );
  Serial.println ( WiFi.channel() );

  // Démarrage serveur web
  //------------------------------------------------------------------
  // Route for root / web page
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send_P(200, "text/html", index_html, processor); });
  
  ChargerVignettes();

  // Send a GET request to <ESP_IP>/update?output=<inputMessage1>&state=<inputMessage2>
  server.on("/update", HTTP_GET, [] (AsyncWebServerRequest *request) {
    String inputMessage1;
    String inputMessage2;
    // GET input1 value on <ESP_IP>/update?output=<inputMessage1>&state=<inputMessage2>
    if (request->hasParam(PARAM_INPUT_1) && request->hasParam(PARAM_INPUT_2)) 
    {
      inputMessage1 = request->getParam(PARAM_INPUT_1)->value();
      inputMessage2 = request->getParam(PARAM_INPUT_2)->value();

      CommandeAppareil(inputMessage1, inputMessage2);
    }
    else 
    {
      inputMessage1 = "Message ";
      inputMessage2 = "KO";
      Serial.print(inputMessage1);
      Serial.println(inputMessage2);
    }
    
    request->send(200, "text/plain", "OK");
  });

  // Start server
  server.begin();

  // Initialisation Appareils
  //------------------------------------------------------------------
  InitialiseAppareils();
  Serial.println ( "Initialisation appareils terminée " );
/*  
  CommandeAppareil("Tst1", "2");
  delay(1000);
  CommandeAppareil("Tst1", "1");
  delay(1000);
  CommandeAppareil("Tst2", "2");
  delay(1000);
  CommandeAppareil("Tst2", "3");
  delay(1000);
  CommandeAppareil("Tst1", "1");
  delay(1000);*/
  
}

/*********************************************************************/
void loop() 
/*********************************************************************/
{
}
